﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Imports Microsoft.Xna.Framework.Audio
Imports Microsoft.Xna.Framework.Content
Imports Microsoft.Xna.Framework.Media
Imports Microsoft.Xna.Framework.Input

Imports FarseerPhysics
Imports FarseerPhysics.Dynamics
Imports FarseerPhysics.Dynamics.Joints
Imports FarseerPhysics.Collision
Imports FarseerPhysics.Factories

Imports System.IO


Public Class Game
    Inherits Microsoft.Xna.Framework.Game
    Dim graphics As GraphicsDeviceManager
    Dim SpriteBatch As SpriteBatch

    Private world As World

    Private woodList As List(Of DrawablePhysicsObject) 'cat 1
    Private stoneList As List(Of DrawablePhysicsObject) 'cat 1 & 2
    Private gemlist As List(Of DrawablePhysicsObject) 'cat 3

    Private link As DrawablePhysicsObject 'cat 10
    Private feet As DrawablePhysicsObject 'cat 10

    Private prevKeyboardState As KeyboardState
    Private prevMouseState As MouseState
    Private random As Random
    'Dim i As Integer
    Dim num_gem As Integer = 0
    Dim myfont As SpriteFont
    Dim msg As String = "."
    Dim _fixedMouseJoint As FixedMouseJoint
    Dim isjumping As Boolean = False

    Dim timer As Integer
    Dim switchFrame As Boolean
    Dim direction_ As Integer

    Private gem_soundeffect As SoundEffect
    Private gem_soundinstance As SoundEffectInstance

    Public Enum direction
        Up = 0
        Down = 1
        Left = 2
        Right = 3
    End Enum

    Dim frame As Integer = 0

    Public Sub New()
        graphics = New GraphicsDeviceManager(Me)
        Window.Title = "Test"
        graphics.PreferMultiSampling = True
        graphics.PreferredBackBufferHeight = 576 - 32  '18*32
        graphics.PreferredBackBufferWidth = 800 - 32   '25*32
        Me.IsMouseVisible = True

    End Sub

    Protected Overrides Sub Initialize()
        'TODO: Add your initialization logic here'

        MyBase.Initialize()


    End Sub
    Sub createworld()
        Dim fs As FileStream = New FileStream(Application.StartupPath + "\level1.txt", FileMode.Open)
        Dim sw As StreamReader = New StreamReader(fs)
        Dim s As String
        Dim prev As String = ""
        Dim x As Integer
        Dim y As Integer
        For y = 0 To 17
            s = sw.ReadLine
            For x = 0 To 24
                If s(x) = "S" Then
                    Dim stone As DrawablePhysicsObject
                    stone = New DrawablePhysicsObject(world, Content.Load(Of Texture2D)("xnb\stone"), New Vector2(32.0F, 32.0F), 0.1F, 0)
                    stone.body.BodyType = BodyType.Static
                    stone.body.CollisionCategories = Category.Cat1
                    stone.body.UserData = "S"
                    stone.Position = New Vector2(x * 32, y * 32)
                    'AddHandler stone.body.OnCollision, AddressOf body_Oncollision
                    stoneList.Add(stone)
                End If
                If s(x) = "F" Then
                    Dim stone As DrawablePhysicsObject
                    stone = New DrawablePhysicsObject(world, Content.Load(Of Texture2D)("xnb\stone"), New Vector2(32.0F, 32.0F), 0.1F, 1)
                    stone.body.BodyType = BodyType.Static
                    'stone.body.FixedRotation = True
                    stone.body.CollisionCategories = Category.Cat2
                    stone.body.UserData = "F"
                    stone.Position = New Vector2(x * 32, y * 32)
                    'AddHandler stone.body.OnCollision, AddressOf body_Oncollision
                    stoneList.Add(stone)
                    If prev = s(x) Then
                        'joint not helping to kill the edge bug
                        'JointFactory.CreateWeldJoint(world, stone.body, stoneList.Item(stoneList.Count - 2).body, stoneList.Item(stoneList.Count - 2).body.Position - stone.body.Position, Vector2.Zero)
                        'W.I.P to kill the edge bug
                        'Dim edgeshape As New FarseerPhysics.Collision.Shapes.EdgeShape(stone.body.Position, stoneList.Item(stoneList.Count - 2).body.Position)
                    End If
                End If
                If s(x) = "W" Then
                    Dim wood As DrawablePhysicsObject
                    wood = New DrawablePhysicsObject(world, Content.Load(Of Texture2D)("xnb\wood"), New Vector2(32.0F, 32.0F), 0.1F, 1)
                    wood.body.BodyType = BodyType.Static
                    wood.body.CollisionCategories = Category.Cat2
                    wood.body.UserData = "W"
                    wood.Position = New Vector2(x * 32, y * 32)
                    'AddHandler wood.body.OnCollision, AddressOf body_Oncollision
                    woodList.Add(wood)
                    If prev = s(x) Then
                        'joint not helping to kill the edge bug
                        'JointFactory.CreateWeldJoint(world, wood.body, woodList.Item(woodList.Count - 2).body, woodList.Item(woodList.Count - 2).body.Position - wood.body.Position, Vector2.Zero)
                    End If
                End If
                If s(x) = "G" Then
                    Dim gem As DrawablePhysicsObject
                    gem = New DrawablePhysicsObject(world, Content.Load(Of Texture2D)("xnb\gem"), New Vector2(20.0F, 20.0F), 0.1F, 0)
                    gem.body.BodyType = BodyType.Static
                    gem.body.CollisionCategories = Category.Cat3
                    gem.body.UserData = "G"
                    gem.Position = New Vector2(x * 32, y * 32)
                    'AddHandler gem.body.OnCollision, AddressOf body_Oncollision
                    gemlist.Add(gem)
                End If
                prev = s(x)
            Next ' For x = 0 To 24
        Next 'For y = 0 To 17

        sw.Close()
        fs.Close()
    End Sub
    Protected Overrides Sub LoadContent()
        SpriteBatch = New SpriteBatch(GraphicsDevice)
        myfont = Content.Load(Of SpriteFont)("xnb\myfont")
        random = New Random()

        ' World is the most important farseer object. It's where
        ' all the objects should be registered and it handles the 
        ' entire simulation via the step function.
        ' Here we instantiate it with earth like gravity
        world = New World(New Vector2(0, 9.81F))


        woodList = New List(Of DrawablePhysicsObject)()
        stoneList = New List(Of DrawablePhysicsObject)()
        gemlist = New List(Of DrawablePhysicsObject)()


        link = New DrawablePhysicsObject(world, Content.Load(Of Texture2D)("xnb\link"), New Vector2(26.0F, 26.0F), 10, 0)
        link.body.BodyType = BodyType.Dynamic
        link.body.CollisionCategories = Category.Cat10
        link.body.UserData = "link"
        link.body.Restitution = 0.2
        link.body.Friction = 1.8
        link.body.FixedRotation = True
        link.Position = New Vector2(50, 525)
        link.body.IgnoreCCD = True
        'collision handler
        AddHandler link.body.OnCollision, AddressOf body_Oncollision

        feet = New DrawablePhysicsObject(world, Content.Load(Of Texture2D)("xnb\feet"), New Vector2(16.0F, 2.0F), 0, 0)
        feet.body.BodyType = BodyType.Dynamic
        feet.body.CollisionCategories = Category.Cat8
        feet.body.UserData = "feet"
        'feet.body.Restitution = 0.2
        'feet.body.Friction = 2
        'feet.body.FixedRotation = True
        feet.Position = link.Position + New Vector2(2, 14)
        feet.body.IsSensor = True
        JointFactory.CreateWeldJoint(world, link.body, feet.body, feet.body.Position - link.body.Position, Vector2.Zero)
        AddHandler feet.body.OnCollision, AddressOf body_Oncollision


        gem_soundeffect = Content.Load(Of SoundEffect)("xnb\gem_sound")
        gem_soundinstance = gem_soundeffect.CreateInstance

        prevKeyboardState = Keyboard.GetState()

        createworld()

        MyBase.LoadContent()

    End Sub
    Protected Overrides Sub UnloadContent()
        MyBase.UnloadContent()
        'TODO: Unload any non ContentManager content here'
    End Sub


    Sub animation()

        timer += 1

        'every 8 keypress, we switch between frame A and B for one specific move
        If (timer = 8) Then
            switchFrame = True
        ElseIf (timer = 16) Then
            timer = 0
            switchFrame = False
        End If

        If (switchFrame = False) Then
            Select Case direction_
                Case direction.Up
                    frame = 5
                Case direction.Down
                    frame = 2
                Case direction.Left
                    frame = 0
                Case direction.Right
                    frame = 7
            End Select
        Else
            Select Case direction_
                Case direction.Up
                    frame = 4
                Case direction.Down
                    frame = 3
                Case direction.Left
                    frame = 1
                Case direction.Right
                    frame = 6
            End Select
        End If


    End Sub

    Protected Overrides Sub Update(ByVal gameTime As Microsoft.Xna.Framework.GameTime)

        'timer += 1
        'If timer > 55 Then
        '    timer = 0
        '    isjumping = False
        'End If


        Dim keyboardState As KeyboardState = Keyboard.GetState()

        If keyboardState.IsKeyDown(Keys.Left) Then
            'crateList.Item(crateList.Count - 1).body.ApplyAngularImpulse(-0.5)
            'crateList.Item(crateList.Count - 1).body.ApplyTorque(-5)
            link.body.ApplyForceVB_byval(New Vector2(-0.5, -0.1))
            direction_ = direction.Left
        End If

        If keyboardState.IsKeyDown(Keys.Right) Then
            'link.body.ApplyAngularImpulse(0.5)
            'link.body.ApplyTorque(5)
            link.body.ApplyForceVB_byval(New Vector2(0.5, -0.1))
            direction_ = direction.Right
        End If

        If keyboardState.IsKeyDown(Keys.Up) Then
            If isjumping = False Then
                link.body.ApplyLinearImpulseVB_byval(New Vector2(0, -0.25F))
                isjumping = True
            End If
        End If

        animation()

        'if all keys up, then freeze
        If keyboardState.IsKeyUp(Keys.Up) AndAlso keyboardState.IsKeyUp(Keys.Down) AndAlso keyboardState.IsKeyUp(Keys.Left) AndAlso keyboardState.IsKeyUp(Keys.Right) Then
            timer = 0
            switchFrame = False
        End If

        prevKeyboardState = keyboardState


        ''mouse joint
        'Dim ms As MouseState = Mouse.GetState
        'msg = ms.X & ":" & ms.Y

        'Dim Position As New Vector2
        'Position = New Vector2(ms.X / DrawablePhysicsObject.unitToPixel, ms.Y / DrawablePhysicsObject.unitToPixel)

        'If (prevMouseState.LeftButton = ButtonState.Released And ms.LeftButton = ButtonState.Pressed) And (_fixedMouseJoint Is Nothing) Then
        '    Dim f As Fixture = world.TestPoint(Position)
        '    If Not f Is Nothing Then
        '        Dim body As Body = f.Body
        '        _fixedMouseJoint = New FixedMouseJoint(body, Position)
        '        _fixedMouseJoint.MaxForce = 1000.0F * body.Mass
        '        world.AddJoint(_fixedMouseJoint)
        '        body.Awake = True
        '    End If 'If Not f Is Nothing Then
        'End If

        'If (prevMouseState.LeftButton = ButtonState.Pressed And ms.LeftButton = ButtonState.Released) And (Not _fixedMouseJoint Is Nothing) Then
        '    world.RemoveJoint(_fixedMouseJoint)
        '    _fixedMouseJoint = Nothing
        'End If

        'If Not _fixedMouseJoint Is Nothing Then _fixedMouseJoint.WorldAnchorB = Position

        'prevMouseState = ms
        ''end of mouse joint


        world.Step(CSng(gameTime.ElapsedGameTime.TotalSeconds))


        MyBase.Update(gameTime)

    End Sub


    Protected Overrides Sub Draw(ByVal gameTime As Microsoft.Xna.Framework.GameTime)
        GraphicsDevice.Clear(Color.CornflowerBlue)

        SpriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend)


        For Each gem As DrawablePhysicsObject In gemlist
            If gem.body.IsDisposed = False Then gem.Draw(SpriteBatch)
        Next

        For Each stone As DrawablePhysicsObject In stoneList
            If stone.body.IsDisposed = False Then stone.Draw(SpriteBatch)
        Next

        For Each wood As DrawablePhysicsObject In woodList
            If wood.body.IsDisposed = False Then wood.Draw(SpriteBatch)
        Next

        link.Draw(SpriteBatch, frame)
        'feet.Draw(SpriteBatch)


        SpriteBatch.DrawString(myfont, "collisions: " & num_gem.ToString, New Vector2(20, 20), Color.White)
        SpriteBatch.DrawString(myfont, msg, New Vector2(20, 40), Color.White)

        SpriteBatch.End()

        MyBase.Draw(gameTime)
    End Sub

    Private Function body_Oncollision(fixtureA As Fixture, fixtureB As Fixture, contact As Contacts.Contact) As Boolean
        Debug.WriteLine(" A:" & fixtureA.Body.BodyId & " cat:" & fixtureA.Body.UserData & " colliding with B:" & fixtureB.Body.BodyId & " cat:" & fixtureB.Body.UserData)

        'link vs wood or stone floor
        If (fixtureA.Body.UserData = "feet") And (fixtureB.Body.UserData = "W" Or fixtureB.Body.UserData = "F") Then
            isjumping = False
        End If


        Debug.WriteLine("isjumping=" & isjumping.ToString)

        'link vs gem
        If (fixtureA.Body.UserData = "link") And (fixtureB.Body.UserData = "G") Then
            'Debug.WriteLine("link vs gem")
            'play a sound
            If (gem_soundinstance.State = SoundState.Stopped) Then
                gem_soundinstance.Volume = 0.75F
                'gem_soundinstance.IsLooped = False
                gem_soundinstance.Play()
            Else
                gem_soundinstance.Resume()
            End If
            '
            num_gem += 1
            If num_gem >= gemlist.Count Then MsgBox("gagné")
            Debug.WriteLine(num_gem & ":" & gemlist.Count)
            fixtureB.Body.Dispose()
            Return False
        Else
            Return True 'false will let the object go thru
        End If


    End Function

End Class

